# DO NOT EDIT! This file was auto-generated by crates/build/re_types_builder/src/codegen/python/mod.rs
# Based on "crates/store/re_types/definitions/rerun/blueprint/components/sort_order.fbs".

# You can extend this class by creating a "SortOrderExt" class in "sort_order_ext.py".

from __future__ import annotations

from typing import Literal, Sequence, Union

import pyarrow as pa

from ..._baseclasses import (
    BaseBatch,
    BaseExtensionType,
    ComponentBatchMixin,
)

__all__ = ["SortOrder", "SortOrderArrayLike", "SortOrderBatch", "SortOrderLike", "SortOrderType"]


from enum import Enum


class SortOrder(Enum):
    """**Component**: Sort order for data table."""

    Ascending = 1
    """Ascending"""

    Descending = 2
    """Descending"""

    @classmethod
    def auto(cls, val: str | int | SortOrder) -> SortOrder:
        """Best-effort converter, including a case-insensitive string matcher."""
        if isinstance(val, SortOrder):
            return val
        if isinstance(val, int):
            return cls(val)
        try:
            return cls[val]
        except KeyError:
            val_lower = val.lower()
            for variant in cls:
                if variant.name.lower() == val_lower:
                    return variant
        raise ValueError(f"Cannot convert {val} to {cls.__name__}")

    def __str__(self) -> str:
        """Returns the variant name."""
        return self.name


SortOrderLike = Union[SortOrder, Literal["Ascending", "Descending", "ascending", "descending"], int]
SortOrderArrayLike = Union[SortOrderLike, Sequence[SortOrderLike]]


class SortOrderType(BaseExtensionType):
    _TYPE_NAME: str = "rerun.blueprint.components.SortOrder"

    def __init__(self) -> None:
        pa.ExtensionType.__init__(self, pa.uint8(), self._TYPE_NAME)


class SortOrderBatch(BaseBatch[SortOrderArrayLike], ComponentBatchMixin):
    _ARROW_TYPE = SortOrderType()

    @staticmethod
    def _native_to_pa_array(data: SortOrderArrayLike, data_type: pa.DataType) -> pa.Array:
        if isinstance(data, (SortOrder, int, str)):
            data = [data]

        pa_data = [SortOrder.auto(v).value if v is not None else None for v in data]  # type: ignore[redundant-expr]

        return pa.array(pa_data, type=data_type)
